<?php
namespace App\Controller\Admin;

//pr($_SERVER); die;
use App\Controller\Admin\Component\ImgComponent;

use App\Controller\Admin\AppController;
use Cake\Event\Event;
use Cake\ORM\TableRegistry;
use Cake\Core\Configure;
use Cake\I18n\Time;
use Cake\View\Helper\TimeHelper;
use Cake\Datasource\ConnectionManager;

//include "http://localhost/raushan/qui/webroot/phpqrcode/qrlib.php";    
/******************************************************************************
*File Name:	 Controller
*Creation Date: [11-02-2016]
*Modification Date: [11-02-2016]
*Author: [Raushan Suri]
*Author: [Modified By Raushan Suri]
*Description: [This controller consist of function related to Department.]
******************************************************************************/
class FeaturesController extends AppController
{

    public function beforeFilter(Event $event)
    {
        parent::beforeFilter($event);
        $this->Auth->allow(['showprofile']);
    }

    
    /********************************************************************************
	Function Name: index
	*Type: Public function used as action of the controller
	*Input: No input
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to view all member list and search.
	*********************************************************************************/
    public function index($productId=null,$userId=NULL)
    {
		$this->loadModel('Products');
        $layoutTitle = 'QuiQR :: Manage Feature';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');
        $limit = 30;//Configure::read('App.adminPageLimit');
        
        $this->paginate = [
            'limit' => $limit,
            'order' => ['Features.created' => 'DESC'],
			//'contain'=>['Users']
			'contain'=>['Users', 'Products']
        ];        
        $keyword = $this->request->query('keyword');
		$USERID = $this->request->query('userId');
		$condition[] = ['Features.productId'=>$productId];
        if($keyword != ''){
			$condition[] = [
				'OR' => [
					["Features.FeatureName LIKE '%".$keyword."%'"],
					["Features.categoryName LIKE '%".$keyword."%'"],
					//["Categories.name LIKE '%".$keyword."%'"],
					//["Features.quantity LIKE '%".$keyword."%'"],
					//["Features.shippingAmount LIKE '%".$keyword."%'"],
				]				
			];
		}
		
        $query = $this->Features->find('all')->where($condition);       
        $features = $this->paginate($query);
        $features = $features->toArray();
		//pr($features);die;
        $this->set(compact('features', 'productId', 'userId', 'usersList'));
    }

      
    /********************************************************************************
	Function Name: add
	*Type: Public function used as action of the controller
	*Input: No input
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to add hours.
	*********************************************************************************/
    public function add($productId=NULL,$userId=NULL)
    {
		$this->loadModel('Users');
		$this->loadModel('Products');
        $layoutTitle = 'QuiQR ::  Add New Feature';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');
		$productList = $this->Products->find('list', ['keyField' => 'id', 'valueField' => ['productName','NCIName']])
						->where(['Products.id'=>$productId])
                        ->order(['Products.productName'=>'ASC'])->toArray();
	    $productList = str_replace(";", " - ", $productList);
		$userList = $this->Users->find('list', ['keyField' => 'id', 'valueField' => ['fullName', 'email']])
						->where(['Users.id'=>$userId])
                        ->order(['Users.fullName'=>'ASC'])->toArray();
        
        $userList = str_replace(";0", " - ", $userList);
		
        $features = $this->Features->newEntity();        
       
        if ($this->request->is('post')) {
			//pr($this->request->data); die;
            $userImage = @$this->request->data['image'];	
			unset($this->request->data['image']);			
			if(!empty($userImage['name'])){
				$filename = time() .'_'. $userImage['name'];
				$this->request->data['image'] = $filename;
			}
			
			$userImage1 = @$this->request->data['document'];	
			unset($this->request->data['document']);			
			if(!empty($userImage1['name'])){
				$filename1 = time() .'_'. $userImage1['name'];
				$this->request->data['document'] = $filename1;
			}
			
			$userImage4 = @$this->request->data['video'];	
			unset($this->request->data['video']);			
			if(!empty($userImage4['name'])){
				$filename4 = time() .'_'. $userImage4['name'];
				$this->request->data['video'] = $filename4;
			}
			
			$features = $this->Features->patchEntity($features, $this->request->data, ['validate' => 'customer']);            
			$features['created'] = date('Y-m-d H:i:s');
			//$path = WWW_ROOT . 'img/uploads/feature/original/';
			if ($this->Features->save($features)) {
				if (!empty($userImage) && $userImage['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/features/';	                    
					move_uploaded_file($userImage['tmp_name'], $path.$filename);
					@chmod($path.$filename, 0777);
				}
				
				if (!empty($userImage1) && $userImage1['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/features/';	                    
					move_uploaded_file($userImage1['tmp_name'], $path.$filename1);
					@chmod($path.$filename1, 0777);
				}
				if (!empty($userImage2) && $userImage2['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/features/';	                    
					move_uploaded_file($userImage2['tmp_name'], $path.$filename2);
					@chmod($path.$filename2, 0777);
				}
				if (!empty($userImage3) && $userImage3['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/features/';	                    
					move_uploaded_file($userImage3['tmp_name'], $path.$filename3);
					@chmod($path.$filename3, 0777);
				}
				if (!empty($userImage4) && $userImage4['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/features/';	                    
					move_uploaded_file($userImage4['tmp_name'], $path.$filename4);
					@chmod($path.$filename4, 0777);
				}
				if (!empty($userImage5) && $userImage5['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/features/';	                    
					move_uploaded_file($userImage5['tmp_name'], $path.$filename5);
					@chmod($path.$filename5, 0777);
				}
				
				$this->Flash->success(__('Feature added successfully.'));
				return $this->redirect(['action' => 'index',$productId,$userId]);	
			}else{
				//pr($users);die;
				$this->Flash->error(__('Unable to add new feature, Please try again later.'));
			}
		}
        $this->set(compact('features','parentClientList','userList','productList'));
    }
    
    
    
    
    /********************************************************************************
	Function Name: edit
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to edit hours.
	*********************************************************************************/
    public function edit($id=NULL,$productId=NULL,$userId=NULL)
    {
		$this->loadModel('Users');
		$this->loadModel('Categories');
		$this->loadModel('Products');
        $layoutTitle = 'QuiQR :: Edit Feature';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');
  
		$userList = $this->Users->find('list', ['keyField' => 'id', 'valueField' => ['fullName', 'email']])
						->where(['Users.id'=>$userId])
                        ->order(['Users.fullName'=>'ASC'])->toArray();
        $userList = str_replace(";", " - ", $userList);
		
		$productList = $this->Products->find('list', ['keyField' => 'id', 'valueField' => ['productName', 'NCIName']])
						->where(['Products.id'=>$productId])
                        ->order(['Products.productName'=>'ASC'])->toArray();
        $productList = str_replace(";", " - ", $productList);
		
		//pr($ProductList); die;
		
        $features = $this->Features->find()->where(['Features.id' => $id])->first();//fields name in contain[] with coma
		
        if ($this->request->is(['patch', 'post', 'put'])) {
			
			$userImage = @$this->request->data['image'];	
			unset($this->request->data['image']);
			unset($features['image']);
			
			$userImage1 = $this->request->data['document'];	
			unset($this->request->data['document']);
			unset($features['document']);
			
			
			$userImage4 = $this->request->data['video'];	
			unset($this->request->data['video']);
			unset($features['video']);
			
			
			$old_data = $this->Features->get($id);            			
			if(!empty($userImage['name'])){
				$filename = time() .'_'. $userImage['name'];
				$features['image'] = $filename;
				$this->request->data['image'] = $filename;
			}
			
			if(!empty($userImage1['name'])){
				$filename1 = time() .'_'. $userImage1['name'];
				$features['PDF1'] = $filename1;
				$this->request->data['document'] = $filename1;
			}
			
			if(!empty($userImage2['name'])){
				$filename2 = time() .'_'. $userImage2['name'];
				$features['PDF2'] = $filename2;
				$this->request->data['PDF2'] = $filename2;
			}
			
			if(!empty($userImage3['name'])){
				$filename3 = time() .'_'. $userImage3['name'];
				$features['PDF3'] = $filename3;
				$this->request->data['PDF3'] = $filename3;
			}
			
			if(!empty($userImage4['name'])){
				$filename4 = time() .'_'. $userImage4['name'];
				$features['video'] = $filename4;
				$this->request->data['video'] = $filename4;
			}
			if(!empty($userImage5['name'])){
				$filename5 = time() .'_'. $userImage5['name'];
				$features['brochure'] = $filename5;
				$this->request->data['brochure'] = $filename5;
			}
			
			$features = $this->Features->patchEntity($features, $this->request->data, ['validate' => 'customer']);
			if(!empty($filename)){				
				$oldfilename = $old_data->image;
			}	
			
			$path = WWW_ROOT . 'img/uploads/feature/original/';
			if ($this->Features->save($features)) {
				if (!empty($userImage) && $userImage['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/features/';	
					@unlink(WWW_ROOT . 'img/uploads/features/'.$oldfilename);
					move_uploaded_file($userImage['tmp_name'], $path.$filename);
					@chmod($path.$filename, 0777);
				}
				
				if (!empty($userImage1) && $userImage1['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/features/';	
					@unlink(WWW_ROOT . 'img/uploads/features/'.$old_data->document);
					move_uploaded_file($userImage1['tmp_name'], $path.$filename1);
					@chmod($path.$filename1, 0777);
				}
				
				if (!empty($userImage2) && $userImage2['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/features/';	
					@unlink(WWW_ROOT . 'img/uploads/features/'.$old_data->PDF2);
					move_uploaded_file($userImage2['tmp_name'], $path.$filename2);
					@chmod($path.$filename2, 0777);
				}
				
				if (!empty($userImage3) && $userImage3['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/features/';	
					@unlink(WWW_ROOT . 'img/uploads/features/'.$old_data->PDF3);
					move_uploaded_file($userImage3['tmp_name'], $path.$filename3);
					@chmod($path.$filename3, 0777);
				}
				
				if (!empty($userImage4) && $userImage4['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/features/';	
					@unlink(WWW_ROOT . 'img/uploads/features/'.$old_data->video);
					move_uploaded_file($userImage4['tmp_name'], $path.$filename4);
					@chmod($path.$filename4, 0777);
				}
				
				if (!empty($userImage5) && $userImage5['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/features/';	
					@unlink(WWW_ROOT . 'img/uploads/features/'.$old_data->brochure);
					move_uploaded_file($userImage1['tmp_name'], $path.$filename5);
					@chmod($path.$filename5, 0777);
				}
				
				if (!empty($userImage1) && $userImage1['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/features/';	
					@unlink(WWW_ROOT . 'img/uploads/features/'.$old_data->image);
					move_uploaded_file($userImage1['tmp_name'], $path.$filename1);
					@chmod($path.$filename1, 0777);
				}
				
				$this->Flash->success(__('The feature updated successfully.'));
                return $this->redirect(['action' => 'index',$productId, $userId]);
			} else {
				
				$this->Flash->error(__('Feature information could not be saved. Please try again later.'));
			}
        }
        $this->set(compact('features','subcategoryList','productList','userList'));
    }
    
    
    /********************************************************************************
	Function Name: delete
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to delete hours permanently.
	*********************************************************************************/
    public function delete($id = null, $productId=NULL, $userId=NULL)
    {
        $users = $this->Features->get($id);
        if ($this->Features->delete($users)) {
			@unlink(WWW_ROOT . 'img/uploads/features/'.$users->image);
			@unlink(WWW_ROOT . 'img/uploads/features/'.$users->video);
			@unlink(WWW_ROOT . 'img/uploads/features/'.$users->document);
            $this->Flash->success(__('Feature has been deleted.'));
        } else {
            $this->Flash->error(__('Feature could not be deleted. Please, try again.'));
        }
        return $this->redirect(['controller' => 'Features', 'action' => 'index',$productId,$userId]);
    }
    
    
    /********************************************************************************
	Function Name: status
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to update hours status.
	*********************************************************************************/
    public function status($id){
		$users = $this->Features->get($id);
		$status = '1';
		$msg = 'activated';
		if($users->status == '1'){
			$status = '0';
			$msg = 'deactivated';
		}
		
		$articles = TableRegistry::get('Features');
		$query = $articles->query();
		$query->update()
			->set(['status' => $status])
			->where(['id' => $id])
			->execute();
		$this->Flash->success(__('Feature has been '.$msg.' successfully.'));
		return $this->redirect(['controller' => 'Features', 'action' => 'index']);
	}
    
    
    /********************************************************************************
	Function Name: details
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to view hours information.
	*********************************************************************************/
    public function details($id){
        $layoutTitle = 'QuiQR ::  Member Details';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');        
		$users = $this->Features->find()->where(['Features.id' => $id])->first();
        if(!empty($users)){
            $this->set(compact('users'));
        }else{
            $this->Flash->error(__('Member doesnot exist.'));
            return $this->redirect(['controller' => 'Features', 'action' => 'index']);
        }
	}
	
	function subcategory($id){
		$this->loadModel('Categories');
        $stateList = $this->Categories->find('list', ['keyField' => 'id', 'valueField' => ['name']])
						->where(['Categories.parentId' => $id])
                        ->order(['Categories.name'=>'ASC'])->toArray();
		$contPe = '<option value="">Sub Category</option>';
		foreach($stateList as $ksy=>$val){
			$contPe .='<option value="'.$ksy.'">'.$val.'</option>';
		}
		//echo json_encode($contPe);
		echo $contPe;
		die;	
						
	}
	
	
}