<?php
namespace App\Controller\Admin;

//pr($_SERVER); die;
use App\Controller\Admin\Component\ImgComponent;

use App\Controller\Admin\AppController;
use Cake\Event\Event;
use Cake\ORM\TableRegistry;
use Cake\Core\Configure;
use Cake\I18n\Time;
use Cake\View\Helper\TimeHelper;
use Cake\Datasource\ConnectionManager;

//include "http://localhost/raushan/qui/webroot/phpqrcode/qrlib.php";    
/******************************************************************************
*File Name:	 Controller
*Creation Date: [11-02-2016]
*Modification Date: [11-02-2016]
*Author: [Raushan Suri]
*Author: [Modified By Raushan Suri]
*Description: [This controller consist of function related to Department.]
******************************************************************************/
class ProductsController extends AppController
{

    public function beforeFilter(Event $event)
    {
        parent::beforeFilter($event);
        $this->Auth->allow(['showprofile']);
    }

    
    /********************************************************************************
	Function Name: index
	*Type: Public function used as action of the controller
	*Input: No input
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to view all member list and search.
	*********************************************************************************/
    public function index($id=null)
    {
		$this->loadModel('Users');
        $layoutTitle = 'QuiQR :: Manage Product';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');
        $limit = 30;//Configure::read('App.adminPageLimit');
        $usersList = $this->Users->find('list', ['keyField' => 'id', 'valueField' => ['fullName']])
                        ->where(['Users.role' => 'Seller'])->order(['Users.fullName'=>'ASC'])->toArray();
        $this->paginate = [
            'limit' => $limit,
            'order' => [
                'Products.created' => 'DESC'
            ],
			'contain'=>['Users']
			//'contain'=>['Categories', 'Subcategories']
        ];        
        $keyword = $this->request->query('keyword');
		$USERID = $this->request->query('userId');
		$condition[] = '';
        if($keyword != ''){
			$condition[] = [
				'OR' => [
					["Products.productName LIKE '%".$keyword."%'"],
					["Products.price LIKE '%".$keyword."%'"],
					//["Categories.name LIKE '%".$keyword."%'"],
					["Products.quantity LIKE '%".$keyword."%'"],
					//["Products.shippingAmount LIKE '%".$keyword."%'"],
				]				
			];
		}
		if($USERID !=''){
			$condition[] = ['Products.userId'=>$USERID];
		}
        $query = $this->Products->find('all')->where($condition);       
        $products = $this->paginate($query);
        $products = $products->toArray();
		//pr($products);die;
        $this->set(compact('products', 'limit', 'usersList'));
    }

      
    /********************************************************************************
	Function Name: add
	*Type: Public function used as action of the controller
	*Input: No input
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to add hours.
	*********************************************************************************/
    public function add()
    {
		$this->loadModel('Users');
		$this->loadModel('Categories');
        $layoutTitle = 'QuiQR ::  Add New Product';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');
		      
//        $parentClientList = $this->Categories->find('list', ['keyField' => 'id', 'valueField' => ['name', 'parentId']])
//						->where(['Categories.parentId'=>'0'])
//                        ->order(['Categories.name'=>'ASC'])->toArray();
//        $regex = "/;[1-9]*/";
//        $replacement = " (Sub)";
//        $fff = str_replace(";0", " (Main)", $parentClientList);
//        
//        $parentClientList = preg_replace($regex, $replacement, $fff);
//		
//		
		$userList = $this->Users->find('list', ['keyField' => 'id', 'valueField' => ['fullName', 'email']])
						->where(['Users.role'=>'Seller'])
                        ->order(['Users.fullName'=>'ASC'])->toArray();
        
        $regex = "/;[1-9]*/";
        $replacement = " - ";
        $fff = str_replace(";0", " (Main)", $userList);
        $userList = preg_replace($regex, $replacement, $fff);
		
        $products = $this->Products->newEntity();        
       
        if ($this->request->is('post')) {
            $userImage = @$this->request->data['image'];	
			unset($this->request->data['image']);			
			if(!empty($userImage['name'])){
				$filename = time() .'_'. $userImage['name'];
				$this->request->data['image'] = $filename;
			}
			
			$userImage1 = @$this->request->data['PDF1'];	
			unset($this->request->data['PDF1']);			
			if(!empty($userImage1['name'])){
				$filename1 = time() .'_'. $userImage1['name'];
				$this->request->data['PDF1'] = $filename1;
			}
			
			$userImage2 = @$this->request->data['PDF2'];	
			unset($this->request->data['PDF2']);			
			if(!empty($userImage2['name'])){
				$filename2 = time() .'_'. $userImage2['name'];
				$this->request->data['PDF2'] = $filename2;
			}
			
			$userImage3 = @$this->request->data['PDF3'];	
			unset($this->request->data['PDF3']);			
			if(!empty($userImage3['name'])){
				$filename3 = time() .'_'. $userImage3['name'];
				$this->request->data['PDF3'] = $filename3;
			}
			
			$userImage4 = @$this->request->data['video'];	
			unset($this->request->data['video']);			
			if(!empty($userImage4['name'])){
				$filename4 = time() .'_'. $userImage4['name'];
				$this->request->data['video'] = $filename4;
			}
			
			$userImage5 = @$this->request->data['brochure'];	
			unset($this->request->data['brochure']);			
			if(!empty($userImage5['name'])){
				$filename5 = time() .'_'. $userImage5['name'];
				$this->request->data['brochure'] = $filename5;
			}
			
			$products = $this->Products->patchEntity($products, $this->request->data, ['validate' => 'customer']);            
			$products['created'] = date('Y-m-d H:i:s');
			//$path = WWW_ROOT . 'img/uploads/feature/original/';
			if ($this->Products->save($products)) {
				if (!empty($userImage) && $userImage['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/products/';	                    
					move_uploaded_file($userImage['tmp_name'], $path.$filename);
					@chmod($path.$filename, 0777);
				}
				
				if (!empty($userImage1) && $userImage1['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/products/';	                    
					move_uploaded_file($userImage1['tmp_name'], $path.$filename1);
					@chmod($path.$filename1, 0777);
				}
				if (!empty($userImage2) && $userImage2['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/products/';	                    
					move_uploaded_file($userImage2['tmp_name'], $path.$filename2);
					@chmod($path.$filename2, 0777);
				}
				if (!empty($userImage3) && $userImage3['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/products/';	                    
					move_uploaded_file($userImage3['tmp_name'], $path.$filename3);
					@chmod($path.$filename3, 0777);
				}
				if (!empty($userImage4) && $userImage4['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/products/';	                    
					move_uploaded_file($userImage4['tmp_name'], $path.$filename4);
					@chmod($path.$filename4, 0777);
				}
				if (!empty($userImage5) && $userImage5['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/products/';	                    
					move_uploaded_file($userImage5['tmp_name'], $path.$filename5);
					@chmod($path.$filename5, 0777);
				}
				
				$errorCorrectionLevel = 'H'; //'L','M','Q','H'
				$matrixPointSize = 10;
				//$url = "http://localhost/raushan/qui/phpqrcode/test.php";
				$url = Configure::read('App.siteurl')."phpqrcode/test.php";
				$data = array('productName' => $products->productName, 'ID' => $products->id);
				$handle = curl_init($url);
				curl_setopt($handle, CURLOPT_POST, true);
				curl_setopt($handle, CURLOPT_POSTFIELDS, $data);
				$returnHeader = curl_exec($handle);
				curl_close($handle);
				
				//echo "<pre>"; print_r($returnHeader); die;
				$this->Flash->success(__('Product added successfully.'));
				return $this->redirect(['action' => 'index']);	
			}else{
				//pr($users);die;
				$this->Flash->error(__('Unable to add new product, Please try again later.'));
			}
		}
        $this->set(compact('products','parentClientList','userList'));
    }
    
    
    
    
    /********************************************************************************
	Function Name: edit
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to edit hours.
	*********************************************************************************/
    public function edit($id)
    {
		$this->loadModel('Users');
		$this->loadModel('Categories');
        $layoutTitle = 'QuiQR :: Edit Product';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');
        
//		$parentClientList = $this->Categories->find('list', ['keyField' => 'id', 'valueField' => ['name', 'parentId']])
//						->where(['Categories.parentId'=>'0'])
//                        ->order(['Categories.name'=>'ASC'])->toArray();
//        $regex = "/;[1-9]*/";
//        $replacement = " (Sub)";
//        $fff = str_replace(";0", " (Main)", $parentClientList);
//        
//        $parentClientList = preg_replace($regex, $replacement, $fff);
//		
//		
		$userList = $this->Users->find('list', ['keyField' => 'id', 'valueField' => ['fullName', 'email']])
						->where(['Users.role'=>'Seller'])
                        ->order(['Users.fullName'=>'ASC'])->toArray();
        
        $regex = "/;[1-9]*/";
        $replacement = " - ";
        $fff = str_replace(";0", " (Main)", $userList);
        $userList = preg_replace($regex, $replacement, $fff);
		
        $products = $this->Products->find()->where(['Products.id' => $id])->first();//fields name in contain[] with coma
		$subcategoryList = $this->Categories->find('list', ['keyField' => 'id', 'valueField' => ['name']])
						->where(['Categories.parentId'=>$products->categoryId])
                        ->order(['Categories.name'=>'ASC'])->toArray();
		
        if ($this->request->is(['patch', 'post', 'put'])) {
			
			$userImage = @$this->request->data['image'];	
			unset($this->request->data['image']);
			unset($products['image']);
			
			$userImage1 = @$this->request->data['PDF1'];	
			unset($this->request->data['PDF1']);
			unset($products['PDF1']);
			
			$userImage2 = @$this->request->data['PDF2'];	
			unset($this->request->data['PDF2']);
			unset($products['PDF2']);
			
			$userImage3 = @$this->request->data['PDF3'];	
			unset($this->request->data['PDF3']);
			unset($products['PDF3']);
			
			$userImage4 = @$this->request->data['video'];	
			unset($this->request->data['video']);
			unset($products['video']);
			
			$userImage5 = @$this->request->data['brochure'];	
			unset($this->request->data['brochure']);
			unset($products['brochure']);
			
			$old_data = $this->Products->get($id);            			
			if(!empty($userImage['name'])){
				$filename = time() .'_'. $userImage['name'];
				$products['image'] = $filename;
				$this->request->data['image'] = $filename;
			}
			
			if(!empty($userImage1['name'])){
				$filename1 = time() .'_'. $userImage1['name'];
				$products['PDF1'] = $filename1;
				$this->request->data['PDF1'] = $filename1;
			}
			
			if(!empty($userImage2['name'])){
				$filename2 = time() .'_'. $userImage2['name'];
				$products['PDF2'] = $filename2;
				$this->request->data['PDF2'] = $filename2;
			}
			
			if(!empty($userImage3['name'])){
				$filename3 = time() .'_'. $userImage3['name'];
				$products['PDF3'] = $filename3;
				$this->request->data['PDF3'] = $filename3;
			}
			
			if(!empty($userImage4['name'])){
				$filename4 = time() .'_'. $userImage4['name'];
				$products['video'] = $filename4;
				$this->request->data['video'] = $filename4;
			}
			if(!empty($userImage5['name'])){
				$filename5 = time() .'_'. $userImage5['name'];
				$products['brochure'] = $filename5;
				$this->request->data['brochure'] = $filename5;
			}
			
			$products = $this->Products->patchEntity($products, $this->request->data, ['validate' => 'customer']);
			if(!empty($filename)){				
				$oldfilename = $old_data->image;
			}	
			
			$path = WWW_ROOT . 'img/uploads/feature/original/';
			if ($this->Products->save($products)) {
				if (!empty($userImage) && $userImage['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/products/';	
					@unlink(WWW_ROOT . 'img/uploads/products/'.$oldfilename);
					move_uploaded_file($userImage['tmp_name'], $path.$filename);
					@chmod($path.$filename, 0777);
				}
				
				if (!empty($userImage1) && $userImage1['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/products/';	
					@unlink(WWW_ROOT . 'img/uploads/products/'.$old_data->PDF1);
					move_uploaded_file($userImage1['tmp_name'], $path.$filename1);
					@chmod($path.$filename1, 0777);
				}
				
				if (!empty($userImage2) && $userImage2['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/products/';	
					@unlink(WWW_ROOT . 'img/uploads/products/'.$old_data->PDF2);
					move_uploaded_file($userImage2['tmp_name'], $path.$filename2);
					@chmod($path.$filename2, 0777);
				}
				
				if (!empty($userImage3) && $userImage3['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/products/';	
					@unlink(WWW_ROOT . 'img/uploads/products/'.$old_data->PDF3);
					move_uploaded_file($userImage3['tmp_name'], $path.$filename3);
					@chmod($path.$filename3, 0777);
				}
				
				if (!empty($userImage4) && $userImage4['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/products/';	
					@unlink(WWW_ROOT . 'img/uploads/products/'.$old_data->video);
					move_uploaded_file($userImage4['tmp_name'], $path.$filename4);
					@chmod($path.$filename4, 0777);
				}
				
				if (!empty($userImage5) && $userImage5['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/products/';	
					@unlink(WWW_ROOT . 'img/uploads/products/'.$old_data->brochure);
					move_uploaded_file($userImage1['tmp_name'], $path.$filename5);
					@chmod($path.$filename5, 0777);
				}
				
				if (!empty($userImage1) && $userImage1['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/products/';	
					@unlink(WWW_ROOT . 'img/uploads/products/'.$old_data->image);
					move_uploaded_file($userImage1['tmp_name'], $path.$filename1);
					@chmod($path.$filename1, 0777);
				}
				
				$errorCorrectionLevel = 'H'; //'L','M','Q','H'
				$matrixPointSize = 10;
				//$url = "http://localhost/raushan/qui/phpqrcode/test.php";
				$url = Configure::read('App.siteurl')."phpqrcode/test.php";
				$data = array('productName' => $products->productName, 'ID' => $products->id);
				$handle = curl_init($url);
				curl_setopt($handle, CURLOPT_POST, true);
				curl_setopt($handle, CURLOPT_POSTFIELDS, $data);
				$returnHeader = curl_exec($handle);
				curl_close($handle);
				$this->Flash->success(__('The product updated successfully.'));
                return $this->redirect(['action' => 'index']);
			} else {
				
				$this->Flash->error(__('Product information could not be saved. Please try again later.'));
			}
        }
        $this->set(compact('products','subcategoryList','parentClientList','userList'));
    }
    
    
    /********************************************************************************
	Function Name: delete
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to delete hours permanently.
	*********************************************************************************/
    public function delete($id = null)
    {
        $users = $this->Products->get($id);
        if ($this->Products->delete($users)) {
            $this->Flash->success(__('Product has been deleted.'));
        } else {
            $this->Flash->error(__('Product could not be deleted. Please, try again.'));
        }
        return $this->redirect(['controller' => 'Products', 'action' => 'index']);
    }
    
    
    /********************************************************************************
	Function Name: status
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to update hours status.
	*********************************************************************************/
    public function status($id){
		$users = $this->Products->get($id);
		$status = '1';
		$msg = 'activated';
		if($users->status == '1'){
			$status = '0';
			$msg = 'deactivated';
		}
		
		$articles = TableRegistry::get('Products');
		$query = $articles->query();
		$query->update()
			->set(['status' => $status])
			->where(['id' => $id])
			->execute();
		$this->Flash->success(__('Product has been '.$msg.' successfully.'));
		return $this->redirect(['controller' => 'Products', 'action' => 'index']);
	}
    
    
    /********************************************************************************
	Function Name: details
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to view hours information.
	*********************************************************************************/
    public function details($id){
		$this->loadModel('Features');
        $layoutTitle = 'QuiQR ::  Member Details';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');        
		$users = $this->Products->find()->where(['Products.id' => $id])->contain(['Users'])->first();
        if(!empty($users)){
			$ProductFeatures 				= $this->Features->find()->where(['Features.productId' =>$id,'Features.categoryName' => 1])->toArray();
			$RegulatoryCompliance 			= $this->Features->find()->where(['Features.productId' =>$id,'Features.categoryName' => 2])->toArray();
			$TransportationStorageSafety 	= $this->Features->find()->where(['Features.productId' =>$id,'Features.categoryName' => 3])->toArray();
			//pr($users);
            $this->set(compact('users','ProductFeatures','RegulatoryCompliance','TransportationStorageSafety'));
        }else{
            $this->Flash->error(__('Product does not exist.'));
            return $this->redirect(['controller' => 'Products', 'action' => 'index']);
        }
	}
	
	function subcategory($id){
		$this->loadModel('Categories');
        $stateList = $this->Categories->find('list', ['keyField' => 'id', 'valueField' => ['name']])
						->where(['Categories.parentId' => $id])
                        ->order(['Categories.name'=>'ASC'])->toArray();
		$contPe = '<option value="">Sub Category</option>';
		foreach($stateList as $ksy=>$val){
			$contPe .='<option value="'.$ksy.'">'.$val.'</option>';
		}
		//echo json_encode($contPe);
		echo $contPe;
		die;	
						
	}
	
	
}