<?php
/**
 * CakePHP(tm) : Rapid Development Framework (http://cakephp.org)
 * Copyright (c) Cake Software Foundation, Inc. (http://cakefoundation.org)
 *
 * Licensed under The MIT License
 * For full copyright and license information, please see the LICENSE.txt
 * Redistributions of files must retain the above copyright notice.
 *
 * @copyright Copyright (c) Cake Software Foundation, Inc. (http://cakefoundation.org)
 * @link      http://cakephp.org CakePHP(tm) Project
 * @since     0.2.9
 * @license   http://www.opensource.org/licenses/mit-license.php MIT License
 */
namespace App\Controller;

use Cake\Controller\Controller;
use Cake\Event\Event;
use Cake\Core\Configure;
use Cake\Mailer\Email;


/**
 * Application Controller
 *
 * Add your application-wide methods in the class below, your controllers
 * will inherit them.
 *
 * @link http://book.cakephp.org/3.0/en/controllers.html#the-app-controller
 */
class AppController extends Controller
{

    /**
     * Initialization hook method.
     *
     * Use this method to add common initialization code like loading components.
     *
     * e.g. `$this->loadComponent('Security');`
     *
     * @return void
     */
    public function initialize()
    {
        parent::initialize();

        $this->loadComponent('RequestHandler');
        $this->loadComponent('Flash');
        //$this->loadComponent('Auth', [
        //    'loginRedirect' => [
        //        'controller' => 'Employers',
        //        'action' => 'index'
        //    ],
        //    'logoutRedirect' => [
        //        'controller' => 'Employers',
        //        'action' => 'index',
        //    ],
        //    'authenticate' => [
        //        'Form' => [
        //            'fields' => ['username' => 'email']
        //        ]
        //    ]
        //]);
    }

    /**
     * Before render callback.
     *
     * @param \Cake\Event\Event $event The beforeRender event.
     * @return void
     */
    public function beforeRender(Event $event)
    {
        $this->set('PATH', Configure::read('App.siteurl'));
        if (!array_key_exists('_serialize', $this->viewVars) &&
            in_array($this->response->type(), ['application/json', 'application/xml'])
        ) {
            $this->set('_serialize', true);
        }
        
		$this->loadModel('GlobalParameters');
		$globalparameters = $this->GlobalParameters->get(1);
		$this->set('GLOBAL', $globalparameters);
		$this->loadModel('Latestnews');
        $latestnews = $this->Latestnews->find('all')->where(['Latestnews.status' => 1])->limit('5')->order(['Latestnews.id' => 'DESC'])->toArray();
		$this->set('latestnews', $latestnews);
    }
    
    /********************************************************************************
	Function Name: sendmail
	*Type: Public function used as action of the controller
	*Input: template variables, mail template, receiver email and email subject
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to send emails.
	*********************************************************************************/
	function sendmail($Email_variables,$mail_template='', $mailto='', $subject='', $mailcc = '',$from='') {	
		$this->autoRender = false;
        //die('dsds');
        //$email = new Email('Smtp');
		$email = new Email('default');
		$email->helpers(array());
        $email->template($mail_template, 'email_layout')
            ->emailFormat('html')
            ->viewVars($Email_variables)		
            ->subject($subject)
            ->to($mailto)
            ->from(['hr@evirtualservices.com'=>'E-virtual services'])
            ->send();
		return true;
	}
    
//	function sendmail($Email_variables,$mail_template='', $mailto='', $subject='', $mailcc = '',$from='') {	
//		$this->autoRender = false;
//        //$email = new Email('default');
//        $email = new Email('Smtp');
//        $email->template($mail_template, 'email_layout')
//            ->emailFormat('html')
//            ->viewVars($Email_variables)		
//            ->subject($subject)
//            ->to($mailto)
//            ->from(['hr@evirtualservices.com'=>'E-virtualservices'])
//            ->send();
//		return true;
//	}
     /********************************************************************************
	Function Name: random_password
	*Type: Public function used as action of the controller
	*Input: No input
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function for generate n length random password.
	*********************************************************************************/
    public function random_password($length = '10'){
		//$this->autoRender = false;	
		$characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		$charactersLength = strlen($characters);
		$randomString = '';
		for ($i = 0; $i < $length; $i++) {
			$randomString .= $characters[rand(0, $charactersLength - 1)];
		}
		return $randomString;		
	}
	
	function sendmail2($to=NULL,$subject=NULL,$message=NULL){
	
		if($to && $subject && $message){
		
		$headder = '<html xmlns="http://www.w3.org/1999/xhtml" style="margin: 0;padding: 0;">
		<head style="margin: 0;padding: 0;">
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8" style="margin: 0;padding: 0;">
		<title style="margin: 0;padding: 0;">Untitled Document</title>
		<link href="http://fonts.googleapis.com/css?family=Raleway:500,300|Lato:300,400,700" rel="stylesheet" type="text/css" style="margin: 0;padding: 0;">
		<style style="margin: 0;padding: 0;">
		* {
			margin: 0;
			padding: 0;
		}
		body {
		}
		.style1 {
			color: #555;
			font-family: "Lato", sans-serif;
			font-size: 14px;
			line-height: 24px;
			margin-bottom: 16px;
		}
		</style>
		</head>

		<body style="margin: 0;padding: 0;" width="100%">
		<table border="0" cellspacing="0" cellpadding="0" style="width:80% ;margin: 0 auto;padding: 0;">
		  <tr style="margin: 0;padding: 0;">
			<td bgcolor="#e5e5e5" align="center" style="padding: 10px 0;margin: 0;"><img src="'.Configure::read('App.siteurl').'img/emailer-logo.png" style="margin: 0;padding: 0;"></td>
		  </tr>
		  <tr style="margin: 0;padding: 0;">
			<td bgcolor="#f4f4f4" style="padding:10px;color: #555;font-family: Lato, sans-serif;font-size: 14px;line-height: 24p margin-bottom: 16px;margin: 0;">'; 
			
			$content = '<div class="style1" style="line-height:10px; padding:5px;color: #555;font-family: &quot;Lato&quot;, sans-serif;font-size: 14px;line-height: 24px;margin-bottom: 16px;">'.$message.'</div>'; 
			
			$footer = '<p>&nbsp;</p><p class="style1" style="font-size: 15px;margin: 0;padding: 0;color: #555;font-family: &quot;Lato&quot;, sans-serif;line-height: 24px;margin-bottom: 16px;"><strong style="margin: 0;padding: 0;"> If you have any query please contact to HR team.</strong></p>
			  
			  </td>
		  </tr>
		  <tr style="margin: 0;padding: 0;">
			<td bgcolor="#1e1e66" style="margin: 0;padding:15px;"><p style="font-size: 13px;text-align: center;color: #FFF;padding-top:15px; margin: 0;padding: 0;font-family: &quot;Lato&quot;, sans-serif;line-height: 24px;margin-bottom: 16px;">
			<strong style="font-size: 18px;margin: 0;padding: 0;">Evirtual HR Team</strong>
			<br style="margin: 0;padding: 0;"><a style="color: #FFF;" href="mailto:hr@evirtualservices.com" target="_blank">hr@evirtualservices.com</a> <br style="margin: 0;padding: 0;"></p></td>
		  </tr>
		</table></body></html>';
		
			$body = $headder.$content.$footer; 
			$headers  = 'MIME-Version: 1.0' . "\r\n";
			$headers .= 'Content-type: text/html; charset=UTF-8' . "\r\n";
			//$headers .= 'To: Mary <mary@example.com>, Kelly <kelly@example.com>' . "\r\n";
			$headers .= 'From: EVS-PORTAL <hr@evirtualservices.com>' . "\r\n";
			// Mail it
			mail($to, $subject, $body, $headers);
			return true; 	
		}
		else{
			return false;
		}
	}
	
	function phpemail($to, $subject, $message){
			$headder = '<html xmlns="http://www.w3.org/1999/xhtml" style="margin: 0;padding: 0;">
		<head style="margin: 0;padding: 0;">
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8" style="margin: 0;padding: 0;">
		<title style="margin: 0;padding: 0;">Untitled Document</title>
		<link href="http://fonts.googleapis.com/css?family=Raleway:500,300|Lato:300,400,700" rel="stylesheet" type="text/css" style="margin: 0;padding: 0;">
		<style style="margin: 0;padding: 0;">
		* {
			margin: 0;
			padding: 0;
		}
		body {
		}
		.style1 {
			color: #555;
			font-family: "Lato", sans-serif;
			font-size: 14px;
			line-height: 24px;
			margin-bottom: 16px;
		}
		</style>
		</head>

		<body style="margin: 0;padding: 0;" width="100%">
		<table border="0" cellspacing="0" cellpadding="0" style="width:80% ;margin: 0 auto;padding: 0;">
		  <tr style="margin: 0;padding: 0;">
			<td bgcolor="#92d050" align="center" style="padding: 10px 0;margin: 0;"><img src="'.Configure::read('App.siteurl').'img/admin/logo-black.png" style="margin: 0;padding: 0;"></td>
		  </tr>
		  <tr style="margin: 0;padding: 0;">
			<td bgcolor="#f4f4f4" style="padding:10px;color: #555;font-family: Lato, sans-serif;font-size: 14px;line-height: 24p margin-bottom: 16px;margin: 0;">'; 
			
			$content = '<div class="style1" style="line-height:10px; padding:5px;color: #555;font-family: &quot;Lato&quot;, sans-serif;font-size: 14px;line-height: 24px;margin-bottom: 16px;">'.$message.'</div>'; 
			
			//$footer = '<p>&nbsp;</p><p class="style1" style="font-size: 15px;margin: 0;padding: 0;color: #555;font-family: &quot;Lato&quot;, sans-serif;line-height: 24px;margin-bottom: 16px;"><strong style="margin: 0;padding: 0;"> If you have any query please call us : +1(844-888-7439)</strong></p>
			  
			  $footer = '</td>
		  </tr>
		  <tr style="margin: 0;padding: 0;">
			<td bgcolor="#97c63c" style="margin: 0;padding:15px;"><p style="font-size: 13px;text-align: center;color: #FFF;padding-top:15px; margin: 0;padding: 0;font-family: &quot;Lato&quot;, sans-serif;line-height: 24px;margin-bottom: 16px;">
			<strong style="font-size: 18px;margin: 0;padding: 0;">QuiQR Support Team</strong>
			<br style="margin: 0;padding: 0;"><a style="color: #FFF;" href="mailto:help@quiqr.com" target="_blank">help@quiqr.com</a> <br style="margin: 0;padding: 0;"></p></td>
		  </tr>
		</table></body></html>';
		
			$fromName = "QuiQR";
			$fromEmail = "help@quiqr.com";
		
		
			$body = $headder.$content.$footer; 
			$headers  = 'MIME-Version: 1.0' . "\r\n";
			$headers .= 'Content-type: text/html; charset=UTF-8' . "\r\n";
			
			$headers .= 'From:  ' . $fromName . ' <' . $fromEmail .'>' . " \r\n" .
            'Reply-To: '.  $fromEmail . "\r\n" .
            'X-Mailer: PHP/' . phpversion();
			// Mail it
			//'Bcc: rksuri2@gmail.com' . "\r\n" .
			//$headers .= 'To: Mary <mary@example.com>, Kelly <kelly@example.com>' . "\r\n";
			//$headers .= 'From: Birthday Reminder <birthday@example.com>' . "\r\n";
			// Mail it
			//$to = 'raushan.kumar@evirtualservices.com';
			mail($to, $subject, $body, $headers);
			return true;
	}
	
	function sendNotificationOnAndroid($deviceToken=NULL,$body=NULL){
	//echo "<pre>"; print_r($body); die;
	//$deviceToken='cFogMm-iQciYPyOBIt_B3g:APA91bEvmiwC8-cW-dVLAksTIlme4fXmnT-_8BhkJoBt7TB51DvO1rakbpEi7qbsNPYp51xL8q7Gl_oi8GLPw5JTpYaWLy1fREzUqyGaoRbkP5iPs4E_mpBkZq3Ncf6n2f2q3qqMlGeA';
			//$GOOGLE_API_KEY ="AIzaSyD4yMIGvYhtbMBtT4udCXW3EkoVL3TXLY4"; // Place your Google API Key
			$GOOGLE_API_KEY = "AAAAYnJr-Os:APA91bHWOIROKGGtcNmAUbGYUIAyRcmt7_sV8B1ybxDH36jaLJDhKS18Y5oSvZKnf0s6Wes46Yqu4SBK8sDEmX72xM2Umb3njid57_KFzq114WgZ_w5xhY4VGv-ZgIqvWhmICBdVDenS";
			//$url = 'https://android.googleapis.com/gcm/send';
			$url = 'https://fcm.googleapis.com/fcm/send';
			
			$body['message'] = $body['message']; 
			$body['gcm.notification.body'] = $body['message']; 
			unset($body['msg']);
			
			
			$fields = array(
				'registration_ids'  => array($deviceToken),
				'data'              => $body,
				'body'              => $body['message']
			);
			$headers = array(
				'Authorization: key=' . $GOOGLE_API_KEY,
				'Content-Type: application/json'
			);

			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
			$result = curl_exec($ch);
			//echo "<pre>"; print_r($result); die;
			if ($result === FALSE) {
				return true;
				die('Curl failed: ' . curl_error($ch));
			}
			else{
				return true;
				//echo $result; die('APP');
			}
			curl_close($ch);
			//echo json_encode($result);die;
			return $result; 
    }
	
	function sednIosPushNotification($deviceToken=NULL,$body=NULL){
	//echo "<pre>"; print_r($body); die;
			//define("GOOGLE_API_KEY", "AIzaSyDVnz4KLZZI3xYmfhP42VoprbQHMDuhKDc"); // Place your Google API Key
			//$GOOGLE_API_KEY ="AIzaSyD4yMIGvYhtbMBtT4udCXW3EkoVL3TXLY4"; // Place your Google API Key
			$GOOGLE_API_KEY = "AAAAYnJr-Os:APA91bHWOIROKGGtcNmAUbGYUIAyRcmt7_sV8B1ybxDH36jaLJDhKS18Y5oSvZKnf0s6Wes46Yqu4SBK8sDEmX72xM2Umb3njid57_KFzq114WgZ_w5xhY4VGv-ZgIqvWhmICBdVDenS";
			//$url = 'https://android.googleapis.com/gcm/send';
			$url = 'https://fcm.googleapis.com/fcm/send';
			
			$body['message'] = $body['message']; 
			$body['gcm.notification.body'] = $body['message']; 
			unset($body['msg']);
			
			
			$fields = array(
				'registration_ids'  => array($deviceToken),
				'data'              => $body,
				'body'              => $body['message']
			);
			$headers = array(
				'Authorization: key=' . $GOOGLE_API_KEY,
				'Content-Type: application/json'
			);

			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
			$result = curl_exec($ch);
			//echo "<pre>"; print_r($result); die('APP');
			if ($result === FALSE) {
				return true;
				die('Curl failed: ' . curl_error($ch));
			}
			else{
				return true;
				//echo $result; die('APP');
			}
			curl_close($ch);
			//echo json_encode($result);die;
			return $result; 
    }
	
}