<?php
/**
 * CakePHP(tm) : Rapid Development Framework (http://cakephp.org)
 * Copyright (c) Cake Software Foundation, Inc. (http://cakefoundation.org)
 *
 * Licensed under The MIT License
 * For full copyright and license information, please see the LICENSE.txt
 * Redistributions of files must retain the above copyright notice.
 *
 * @copyright Copyright (c) Cake Software Foundation, Inc. (http://cakefoundation.org)
 * @link      http://cakephp.org CakePHP(tm) Project
 * @since     0.2.9
 * @license   http://www.opensource.org/licenses/mit-license.php MIT License
 */
namespace App\Controller;

use Cake\Core\Configure;
use Cake\View\Helper\HtmlHelper;
use Cake\Network\Exception\NotFoundException;
use Cake\View\Exception\MissingTemplateException;
use Cake\Routing\Router;
use Cake\Auth\DefaultPasswordHasher;
use Cake\ORM\TableRegistry;
use Cake\Datasource\ConnectionManager;

use Cake\View\Helper\PaginatorHelper;
/**
 * Static content controller
 *
 * This controller will render views from Template/Pages/
 *
 * @link http://book.cakephp.org/3.0/en/controllers/pages-controller.html
 */

$req_dump = '-------------------------'.date('Y-m-d H:i:s').'---------------------';
$inputJSON = file_get_contents('php://input');
if($inputJSON){
	$input = json_decode($inputJSON, TRUE);
$req_dump .= print_r($input, TRUE);
}
$req_dump .= print_r($_POST, TRUE);
$req_dump .= print_r($_FILES, TRUE);
$fp = fopen('request.log', 'a');
fwrite($fp, $req_dump);
fclose($fp);

class ServicesController extends AppController
{
    var $profilePath 		= 'http://demo2.evirtualservices.com/QuiQR/site/img/uploads/users/';
				var $dashboardPath = 'http://demo2.evirtualservices.com/QuiQR/site/img/uploads/dashboard/';
				var $catPath 						= 'http://demo2.evirtualservices.com/QuiQR/site/img/uploads/category/';
				var $productPath 		= 'http://demo2.evirtualservices.com/QuiQR/site/img/uploads/products/';
				var $featuresPath 	= 'http://demo2.evirtualservices.com/QuiQR/site/img/uploads/features/';
				var $baseUrl 						= 'http://demo2.evirtualservices.com/QuiQR/site/';
	function index(){
		//header("Content-type:application/json");
		Configure::write('Session.checkAgent', false);
		$response=array();
		//$this->layout='';
		if($this->request->data('action') !=''){
			$this->request->data=$this->request->data;
			}else{
					$inputJSON = file_get_contents('php://input');
					if($inputJSON){
						$this->request->data = json_decode($inputJSON, TRUE);
					}
			}
			$action = trim($this->request->data['action']);
					//echo $action;
					//pr($this->request->data); die;
				if(!empty($action)){
						$response = $this->$action();
						unset($this->request->data['action']);
				}else{
						$response['status'] = 'Fails';
						$response['msg'] = 'Invalid action key';
				}
				echo json_encode($response); die;
	}
    
	private function registration(){
		$this->loadModel('Users');
		if($this->request->data('email') !='' && $this->request->data('fullName') !='' && $this->request->data('password') !=''){
			$this->loadModel('Users');
			$usr = $this->Users->find()->where(['Users.email' => $this->request->data('email')])->first();
			if(!empty($usr)){
				$response['status'] = 'Fails';
				$response['msg'] = 'Email already registred with QuiQR';
			}else{
					$this->request->data['password'] = str_replace(' ', '', $this->request->data('password'));
					$this->request->data['email'] = str_replace(' ', '', $this->request->data('email'));
					$this->request->data['Pcode'] = base64_encode($this->request->data['password']);
					$users = $this->Users->newEntity();
					$users = $this->Users->patchEntity($users, $this->request->data, ['validate' => false]);
					$users['created'] 	= date('Y-m-d H:i:s');
					$users['username'] 	= $this->request->data('email');
					$users['status'] 	= '1';
					//$users['role'] 		= 'Member';
					$fileName = '';
					if(@$_FILES['image']['name']){
						$fileName=time().stripslashes($_FILES['image']['name']);
						$fileName= str_replace(" ","",$fileName);
						$users['profile_picture']=$fileName;
					}
					//$path = WWW_ROOT . 'img/uploads/feature/original/';
					if ($this->Users->save($users)) {
							if(@$_FILES['image']['name'] !='' && $fileName !=''){
									$target = WWW_ROOT.'/img/uploads/users/'.$fileName;
									$source=$_FILES['image']['tmp_name'];
									move_uploaded_file($source,$target);
							}
								$response['status'] = 'success';
								$response['msg'] = 'Data save successfully.';
								//@mail('raushan.kumar@evirtualservices.com', 'HELLO', 'YES test mail');
								$to=$this->request->data('email');
								//$to='raushan.kumar@evirtualservices.com';
								$subject="QuiQR Registration";
								$message="Dear ".ucfirst($this->request->data('fullName'));
								$message .= '<br>Your new <strong><span style="color:#2133A1">QuiQR</span> Account has been created. Welcome to the <strong><span style="color:#2133A1">QuiQR</span></strong> family!';
								$message .= '<br>From now on, please log in to your account using your email address and password.';
								$message .='<br><br> Thank you for registering with <strong><span style="color:#2133A1">QuiQR</span>. Your credentials are given below:';
								$message .='<br>Name: '.ucfirst($this->request->data['fullName']);
								$message .='<br>Email: '.$this->request->data('email').'<br>Password: '.$this->request->data['password'];
								$this->phpemail($to, $subject, $message);
								$dd = $this->profile($users->id);
								$TADMIN = 'kbrancato@quiqrsamples.com';
								$this->phpemail($TADMIN, $subject, $message);
								
								$response['data'] = $dd['data'];
					}
			}
		}else{
			$response['status'] = 'Fails';
			$response['msg'] = 'Email, contactNumber,fullName and password required';
		}
		return  $response;
	}
	
	
	private function login($slug=NULL){
		if($this->request->data){
			//pr($this->request->data); die;
			$this->loadModel('Users');
			//$usr = $this->Users->find()->where(['Users.email' => $this->request->data('email')])->first();
			$usr = $this->Users->find()->where(['OR'=>[['Users.email' => $this->request->data('email')],['Users.contactNumber' => $this->request->data('email')]]])->first();
				if(!empty($usr)){
						$check = (new DefaultPasswordHasher)->check(trim($this->request->data('password')),$usr->password);
						if($check && $usr->status == 1){
								//$userdetail['FreedomUsers'] = $usr;
								//$this->request->session()->write($userdetail);
								$usr = $this->Users->patchEntity($usr, $this->request->data, ['validate' => false]);
								$this->Users->save($usr);
								$response['status'] = 'success';
								$response['msg'] = 'Data save successfully.';
								$RES = $this->profile($usr->id);
								$response['data'] = $RES['data'];
								//$response['data'] = $this->profile($users->id);
						}else{
								$response['status'] = 'Fails';
								$response['msg'] = 'Email or password is wrong.';
						}
				}else{
						$response['status'] = 'Fails';
						$response['msg'] = 'Email or password is wrong.';
				}
		}else{
				$response['status'] = 'Fails';
				$response['msg'] = 'Email or password is required.';
		}
			return  $response;
	}
	
	
	function profile($userId = NULL){
			$this->loadModel('Users');
			$this->loadModel('Reviews');
			
			@$userID = ($userId) ? $userId : $this->request->data('userId');
			
			$userD = $this->Users->find()->where(['Users.id' => $userID])->first();
			//pr($userD); die;
			if($userD){
						$UserDetail['userId'] 								= ($userD->id) ? $userD->id : '';
						$UserDetail['fullName'] 						= ($userD->fullName) ? $userD->fullName : '';
						$UserDetail['lastName'] 						= ($userD->lastName) ? $userD->lastName : '';
						$UserDetail['middleName'] 				= ($userD->middleName) ? $userD->middleName : '';
						$UserDetail['email'] 									= ($userD->email) ? $userD->email : '';
						$UserDetail['gender'] 								= ($userD->gender) ? $userD->gender : '';
						$UserDetail['role'] 										= ($userD->role) ? $userD->role : '';
						$UserDetail['dob'] 											= ($userD->dob) ? $userD->dob : '';
						$UserDetail['address'] 							= ($userD->address) ? $userD->address : '';
						$UserDetail['zipCode'] 							= ($userD->zipCode) ? $userD->zipCode : '';
						$UserDetail['state'] 									= ($userD->state) ? $userD->state : '';
						$UserDetail['country'] 							= ($userD->country) ? $userD->country :'';
						$UserDetail['contactNumber'] 	= ($userD->contactNumber) ? $userD->contactNumber :'';
						
						$UserDetail['latitude'] 							= ($userD->latitude) ? $userD->latitude :'';
						$UserDetail['longitude'] 							= ($userD->longitude) ? $userD->longitude :'';
						
						$UserDetail['image'] 									= ($userD->profile_picture) ? $this->profilePath.$userD->profile_picture : '';
						if(strpos($userD->profile_picture, "http") !== false){
							$UserDetail['image'] = $userD->profile_picture;
						}
						
						//$UserDetail['companyBackground'] = ($userD->companyBackground) ? $this->profilePath.$userD->companyBackground : '';
						//$UserDetail['ssnImage'] 									= ($userD->ssnImage) ? $this->profilePath.$userD->ssnImage : '';
						//$UserDetail['AutoInsurance'] 				= ($userD->AutoInsurance) ? $this->profilePath.$userD->AutoInsurance : '';
						//$UserDetail['drivlingImage'] 				= ($userD->drivlingImage) ? $this->profilePath.$userD->drivlingImage : '';
						
						$UserDetail['device'] 							= ($userD->device) ? $userD->device : '';
						$UserDetail['deviceToken'] 		= ($userD->deviceToken) ? $userD->deviceToken : '';
						$UserDetail['firebaseId'] 			= ($userD->firebaseId) ? $userD->firebaseId : '';
						$UserDetail['socialId'] 					= ($userD->socialId) ? $userD->socialId : '';
						$UserDetail['socialType'] 			= ($userD->socialType) ? $userD->socialType : '';
						
						$UserDetail['BankName'] 							= ($userD->BankName) ? $userD->BankName : '';
						$UserDetail['AccountHolderName'] 		= ($userD->AccountHolderName) ? $userD->AccountHolderName : '';
						$UserDetail['AccountNo'] 					= ($userD->AccountNo) ? $userD->AccountNo : '';
						$UserDetail['RoutingNo'] 					= ($userD->RoutingNo) ? $userD->RoutingNo : '';
						$UserDetail['accountType'] 			= ($userD->accountType) ? $userD->accountType : '';
						
						$UserDetail['wallet'] 									= ($userD->wallet) ? $userD->wallet : 0;
						
						$UserDetail['organization'] 									= ($userD->organization) ? $userD->organization : '';
						
						$response['status'] = 'success';
						$response['data'] = $UserDetail;
			
			}else{
					$response['status'] = 'Fails';
					$response['msg'] = 'UserId required';
			}
			
			return  $response;
	}
	
	function socialLoginAction(){
		$this->loadModel('Users');
		if($this->request->data('email') !='' && $this->request->data('fullName') !='' && $this->request->data('socialId') !='' && $this->request->data('socialType') !=''){
			$this->loadModel('Users');
			$usr = $this->Users->find()->where(['Users.socialId' => $this->request->data('socialId'),'Users.socialType' => $this->request->data('socialType')])->first();
			$users = $this->Users->find()->where(['Users.email' => $this->request->data('email')])->first();
			if(empty($usr)){
				if(empty($users)){
					$users = $this->Users->newEntity();
				}
				$users = $this->Users->patchEntity($users, $this->request->data, ['validate' => false]);
				$users['created'] 	= date('Y-m-d H:i:s');
				$users['username'] 	= $this->request->data('email');
				$users['status'] 	= '1';
				$users['role'] 		= 'Member';
				//$users['profile_picture'] 		= $this->request->data('image');
				
				//$path = WWW_ROOT . 'img/uploads/feature/original/';
				if ($this->Users->save($users)) {
							$response['status'] = 'success';
							$response['msg'] = 'Data save successfully.';
							$response['data'] = $this->profile($users->id);
				}
			}else{
				$response['status'] = 'success';
				$response['msg'] = 'Data save successfully.';
				$response['data'] = $this->profile($usr->id);
			}
		}else{
			$response['status'] = 'Fails';
			$response['msg'] = 'Email, fullName, socialId and socialType required';
		}
		return  $response;
	}
	
	
	private function editprofile(){
		$this->loadModel('Users');
		if($this->request->data('userId') !=''){
			$this->loadModel('Users');
			$users = $this->Users->find()->where(['Users.id' => $this->request->data('userId')])->first();
			if(!empty($users)){
				//@unset($this->request->data('email'));
				$users = $this->Users->patchEntity($users, $this->request->data, ['validate' => false]);
				$fileName = '';
				if(@$_FILES['image']['name']){
					$fileName=time().stripslashes($_FILES['image']['name']);
					$fileName= str_replace(" ","",$fileName);
					$users['profile_picture']=$fileName;
					$url = $this->profilePath.$users->profile_picture;
					@unlink($url);
				}
				$fileName2 = '';
				if(@$_FILES['ssnImage']['name']){
					$fileName2=time().stripslashes($_FILES['ssnImage']['name']);
					$fileName2= str_replace(" ","",$fileName2);
					$users['ssnImage']=$fileName2;
					$url = $this->profilePath.$users->ssnImage;
					@unlink($url);
				}
				$fileName3 = '';
				if(@$_FILES['drivlingImage']['name']){
					$fileName3=time().stripslashes($_FILES['drivlingImage']['name']);
					$fileName3= str_replace(" ","",$fileName3);
					$users['drivlingImage']=$fileName3;
					$url = $this->profilePath.$users->drivlingImage;
					@unlink($url);
				}
				$fileName4 = '';
				if(@$_FILES['AutoInsurance']['name']){
					$fileName4=time().stripslashes($_FILES['AutoInsurance']['name']);
					$fileName4= str_replace(" ","",$fileName4);
					$users['AutoInsurance']=$fileName4;
					$url = $this->profilePath.$users->AutoInsurance;
					@unlink($url);
				}
				$fileName5 = '';
				if(@$_FILES['companyBackground']['name']){
					$fileName5=time().stripslashes($_FILES['companyBackground']['name']);
					$fileName5= str_replace(" ","",$fileName5);
					$users['companyBackground']=$fileName5;
					$url = $this->profilePath.$users->companyBackground;
					@unlink($url);
				}
				//$path = WWW_ROOT . 'img/uploads/feature/original/';
				if ($this->Users->save($users)) {
						if(@$_FILES['image']['name'] !='' && $fileName !=''){
								$target = WWW_ROOT.'/img/uploads/users/'.$fileName;
								$source=$_FILES['image']['tmp_name'];
								move_uploaded_file($source,$target);
						}
						if(@$_FILES['ssnImage']['name'] !='' && $fileName2 !=''){
								$target = WWW_ROOT.'/img/uploads/users/'.$fileName2;
								$source=$_FILES['ssnImage']['tmp_name'];
								move_uploaded_file($source,$target);
						}
						if(@$_FILES['drivlingImage']['name'] !='' && $fileName3 !=''){
								$target = WWW_ROOT.'/img/uploads/users/'.$fileName3;
								$source=$_FILES['drivlingImage']['tmp_name'];
								move_uploaded_file($source,$target);
						}
						if(@$_FILES['AutoInsurance']['name'] !='' && $fileName4 !=''){
								$target = WWW_ROOT.'/img/uploads/users/'.$fileName4;
								$source=$_FILES['AutoInsurance']['tmp_name'];
								move_uploaded_file($source,$target);
						}
						if(@$_FILES['companyBackground']['name'] !='' && $fileName5 !=''){
								$target = WWW_ROOT.'/img/uploads/users/'.$fileName5;
								$source=$_FILES['companyBackground']['tmp_name'];
								move_uploaded_file($source,$target);
						}
							$response['status'] = 'success';
							$response['msg'] = 'Data save successfully.';
							$DD = $this->profile($users->id);
							$response['data'] = $DD['data'];
				}
			}else{
				$response['status'] = 'Fails';
				$response['msg'] = 'UserId does not exist';
			}
		}else{
			$response['status'] = 'Fails';
			$response['msg'] = 'UserID is required';
		}
		return  $response;
	}
	
	
	function changepassword(){
		$this->loadModel('Users');
		if($this->request->data('userId')){
			$users = $this->Users->find()->Where(['Users.id' => $this->request->data('userId')])->first();
			$check = (new DefaultPasswordHasher)->check($this->request->data('oldPassword'), $users->password);
			if($check){
				$users = $this->Users->patchEntity($users, ['password'=> $this->request->data('newPassword'),'Pcode' => base64_encode($this->request->data['newPassword'])],['validate' => false]);
				$this->Users->save($users);
				$response['status'] = 'success';
				$response['msg'] = 'Password update successfully.';
			}else{
				$response['status'] = 'Fails';
				$response['msg'] = 'Current password does not match.';
			}
		}else{
			$response['status'] = 'Fails';
			$response['msg'] = 'UserId is required.';
		}
		return  $response;
	}
	
	function forgotpassword(){
		$this->loadModel('Users');
		if($this->request->data('email')){
			$users = $this->Users->find()->Where(['Users.email' => $this->request->data('email')])->first();
			$OLDPASS = base64_decode(@$users->Pcode);
			//$check = (new DefaultPasswordHasher)->check($this->request->data('oldPassword'), $users->password);
			if($users){
				$newPasss = rand(1111111,99999999);
				$users = $this->Users->patchEntity($users, ['password'=> $newPasss],['validate' => false]);
				$this->Users->save($users);
				$to = $users->email;
				//$to = 'raushan.kumar@evirtualservices.com';
				$subject = 'QuiQR-Reset Password '.$to;
				$message="Dear ".ucfirst($users->fullName);
				$message.="<br><br>You have requested for your QUIQR  password to be reset. Your new login credentials are given below:";
				$message.='<br>Name: '.ucfirst($users->fullName);
				$message.='<br>Email: '.$this->request->data['email'].'<br>Password: '.$newPasss;
				$this->phpemail($to,$subject,$message);
				//echo mail('rksuri2@gmail.com', 'HI', 'HELLO'); die('+++');
				$response['status'] = 'success';
				$response['email'] = $users->email;
				$response['newpassword'] = $newPasss;
				$response['oldpassword'] = $OLDPASS;
				$response['msg'] = 'Password sent to the registered email.';
			}else{
				$response['status'] = 'Fails';
				$response['msg'] = 'Email does not exist with QuiQR.';
			}
		}else{
			$response['status'] = 'Fails';
			$response['msg'] = 'email is required.';
		}
		return  $response;
	}
	
	
	function termAndConditions(){
		$this->loadModel('Pages');
		
		$pages = $this->Pages->find()->Where(['Pages.id' => 5])->first();
		$response['status'] = 'success';
		$response['msg'] = $pages->content;
		return  $response;
	}
	function privacypolicy(){
		$this->loadModel('Pages');
		$pages = $this->Pages->find()->Where(['Pages.id' => 4])->first();
		$response['status'] = 'success';
		$response['msg'] = $pages->content;
		return  $response;
	}
	
				
				function statefind(){
						$this->loadModel('States');
						$Sate = $this->request->data('stateName');
						$parentCountryList = $this->States->find()
																								->where(['States.name LIKE'=>'%'.$Sate.'%'])
                        ->order(['States.name'=>'ASC'])->first();
						
						$response['status'] = "success";
						$response['name'] 	= ($parentCountryList->name) ? $parentCountryList->name : '';
						$response['stateCode'] 	= ($parentCountryList->stateCode) ? $parentCountryList->stateCode : '';
						$response['price'] = ($parentCountryList->price) ? $parentCountryList->price : "0";
						return $response;
				}
				
			function category(){
					$this->loadModel('Categories');
					$conditons = array('Categories.status' => '1' , 'Categories.parentId' => 0);
					if(isset($this->request->data['keyword']) && $this->request->data['keyword'] !=''){
						$conditons = array('Categories.name LIKE' =>'%'.$this->request->data['keyword'].'%','Categories.status' => '1' , 'Categories.parentId' => 0);
					}
					$cat=$this->Categories->find('all')->where($conditons)->select(['Categories.id','Categories.name','Categories.image','Categories.bigImage'])->toArray();
					$gautam=array();
					$i=0;
					//$cat=$this->array_filter_recursive($cat);
					foreach($cat as $v){
						$gautam[$i]['id'] 				=  $v->id;
						$gautam[$i]['name'] 		= $v->name;
						$gautam[$i]['image'] 	= ($v->image) ? $this->catPath.$v->image : '';
						$sub = $this->Categories->find('all')->where(["Categories.parentId" => $v->id, 'Categories.status' => '1'])->select(['Categories.id','Categories.name','Categories.image','Categories.bigImage'])->toArray();
						//$gautam[$i]["SubCat"] = $sub;
						$subb = array();
						foreach($sub as $keyy=>$vc){
							$subb[$keyy]['id'] 					= $vc->id;
							$subb[$keyy]['name'] 			= $vc->name;
							$subb[$keyy]['image'] 		= ($vc->image) ? $this->catPath.$vc->image : '';
						}
						$gautam[$i]["SubCat"] = ($subb) ? $subb : array();
						$i++; 
					}
					$response['status'] = "success";
					$response['data'] = ($gautam) ? $this->array_filter_recursive($gautam) : array();
					return $response; 
			}
			
			function productdetail($productId=null){
				$this->loadModel('Products');$this->loadModel('Features');
				$this->loadModel('Users');
				$PRoductID = ($productId) ? $productId : $this->request->data('productId');
				$products = $this->Products->find()->where(['Products.id'=>$PRoductID])->contain(['Users'])->first();
				
					$array['productId'] 		= (@$products->id) ? @$products->id : '';
					$array['userId'] 					= (@$products->userId) ? @$products->userId : '';
					$array['userImage'] 		= ($products->user->profile_picture) ? $this->profilePath.$products->user->profile_picture : '';
					$array['productName'] = (@$products->productName) ? @$products->productName : '';
					$array['NCIName'] 				= (@$products->NCIName) ? @$products->NCIName : '';
					$array['PDF1'] 							= (@$products->PDF1) ? $this->productPath.@$products->PDF1: '';
					$array['PDF2'] 							= (@$products->PDF2) ? $this->productPath.@$products->PDF2: '';
					$array['PDF3'] 							= (@$products->PDF3) ? $this->productPath.@$products->PDF3: '';
					$array['video'] 						= (@$products->video) ? $this->productPath.@$products->video: '';
					$array['brochure'] 			= (@$products->brochure) ? $this->productPath.@$products->brochure: '';
					$array['contactEmail']= (@$products->contactEmail) ? @$products->contactEmail: '';
					
					$ProductFeatures 													= $this->Features->find()->where(['Features.productId' =>$products->id,'Features.categoryName' => 1])->toArray();
					$RegulatoryCompliance 								= $this->Features->find()->where(['Features.productId' =>$products->id,'Features.categoryName' => 2])->toArray();
					$TransportationStorageSafety 	= $this->Features->find()->where(['Features.productId' =>$products->id,'Features.categoryName' => 3])->toArray();
					$PFeatures = array();
					$k=0;
					if($ProductFeatures){
						foreach($ProductFeatures as $DETAILS){
							$PFeatures[$k]['FeatureName'] = $DETAILS->FeatureName;
							$PFeatures[$k]['image'] 						= ($DETAILS->image) ? $this->featuresPath.$DETAILS->image : '';
							$PFeatures[$k]['video'] 						= ($DETAILS->video) ? $this->featuresPath.$DETAILS->video : '';
							$PFeatures[$k]['document'] 			= ($DETAILS->document) ? $this->featuresPath.$DETAILS->document : '';
							$k++;
						}
					}
					$j=0;$RC = array();
					if($RegulatoryCompliance){
						foreach($RegulatoryCompliance as $DETAILS){
							$RC[$j]['FeatureName'] = $DETAILS->FeatureName;
							$RC[$j]['image'] 						= ($DETAILS->image) ? $this->featuresPath.$DETAILS->image : '';
							$RC[$j]['video'] 						= ($DETAILS->video) ? $this->featuresPath.$DETAILS->video : '';
							$RC[$j]['document'] 			= ($DETAILS->document) ? $this->featuresPath.$DETAILS->document : '';
							$j++;
						}
					}
					
					$z=0;$TS = array();
					if($TransportationStorageSafety){
						foreach($TransportationStorageSafety as $DETAILS){
							$TS[$z]['FeatureName'] = $DETAILS->FeatureName;
							$TS[$z]['image'] 						= ($DETAILS->image) ? $this->featuresPath.$DETAILS->image : '';
							$TS[$z]['video'] 						= ($DETAILS->video) ? $this->featuresPath.$DETAILS->video : '';
							$TS[$z]['document'] 			= ($DETAILS->document) ? $this->featuresPath.$DETAILS->document : '';
							$z++;
						}
					}
				
					$user = $this->Users->find()->where(['Users.id'=>@$this->request->data('userId')])->first();
					if(@$user->id !=''){
						$to='kbrancato@quiqrsamples.com';
						//$to='raushan@mailinator.com';
						$subject="PRODUCT e-Mail Contact";
						$message  ="Hi,";
						$message .= '<br>Please note that '.@$user->fullName.' from '.@$user->organization.' viewed '.@$products->productName.' on '.date("F jS, Y, g:i a");
						//$message .= '<br>Feel free to follow up with '.@$user->fullName.' to see if they need further assistance with your product.';
						$this->phpemail($to, $subject, $message);
					}
					
					if(@$products->user->email !=''){
						$to=$products->user->email;
						//$to='raushan@mailinator.com';
						$subject="PRODUCT e-Mail Contact";
						$message  ="Hi,";
						$message .= '<br>Please note that '.@$user->fullName.' from '.@$user->organization.' viewed '.@$products->productName.' on '.date("F jS, Y, g:i a");
						//$message .= '<br>Feel free to follow up with '.@$user->fullName.' to see if they need further assistance with your product.';
						$this->phpemail($to, $subject, $message);
					}
				
					$response['status'] 		= "success";
					$response['data'] = ($array) ? $array : array();
					$response['PFeatures'] = ($PFeatures) ? $PFeatures : array();
					$response['RegulatoryCompliance'] = ($RC) ? $RC : array();
					$response['TransportationStorageSafety'] = ($TS) ? $TS : array();
					return $response; 
			}
			
			
			
			
			
			
	function logout(){
		$articles = TableRegistry::get('Users');
			$query = $articles->query();
			$query->update()
				->set(['deviceToken'=>'','lastLogin'=>date('Y-m-d H:i:s')])
				->where(['id' => $this->request->data['userId']])
				->execute();
				$response['status'] = 'success';
				return  $response;
	}
	
	
	function array_filter_recursive($array) {
		foreach ($array as $key => & $value) {
			if (is_array($value)) {
				$value = $this->array_filter_recursive($value);
			}
			else {
				if ( ! is_null($value)) {
				}
				else {
					$array[$key] = '';
				}
			}
		}
		return $array;
	}
	
	function help(){
				
				$data['phone'] 	= '180-234-5678';
				$data['eamil'] = 'support@quiqrsamples.com';
				$response['status'] = 'success';
				$response['data'] = $data;
				return  $response;
		
	}
	
	function checknotifination($id=NULL){
		$deciceId = ($id) ? $id : $this->request->data['deviceToken'];
		$body['message'] = 'YES HELLO';
		$this->sendNotificationOnAndroid($deciceId,$body);
	}
	//(array) $object;  //Object to array();
	//function array_filter_recursive_object($array) {
	function array_filter_recursive_object(array &$array){
		foreach ($array as $key => &$value) {
		  if (is_array($value)) {
			$value = $this->array_filter_recursive_object($value);
		  }
		  if (empty($value)) {
			$array[$key] = '';
		  }
		}
		return $array;
	}

	
	
	
}