<?php
namespace App\Controller\Subadmin;
use App\Controller\Admin\Component\ImgComponent;

use App\Controller\Subadmin\AppController;
use Cake\Event\Event;
use Cake\ORM\TableRegistry;
use Cake\Core\Configure;
use Cake\I18n\Time;
use Cake\View\Helper\TimeHelper;
use Cake\Routing\Router;
/******************************************************************************
*File Name:	 DepartmentsController
*Creation Date: [11-02-2016]
*Modification Date: [11-02-2016]
*Author: [Raushan Suri]
*Author: [Modified By Raushan Suri]
*Description: [This controller consist of function related to Department.]
******************************************************************************/
class UsersController extends AppController
{

    public function beforeFilter(Event $event)
    {
        parent::beforeFilter($event);
        //$this->Auth->allow(['showprofile']);
    }

    
    /********************************************************************************
	Function Name: index
	*Type: Public function used as action of the controller
	*Input: No input
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to view all member list and search.
	*********************************************************************************/
    public function index()
    {
        $layoutTitle = 'QuiQR::Manage Member';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');
        $limit = Configure::read('App.adminPageLimit');
        $url = Router::url('/', true);
		$breadcum = [
					 'Title' => 'User Management/User Listing',
					 'URL'=>[
							   'Dashboard' => $url,
							   'User Listing' => ''
							]
					 ];
        $this->paginate = [
            'limit' => '30',//$limit,
            'order' => [
                'Users.created' => 'desc'
            ],
            //'contain' => ['ReportedProfiles']
        ];        
        $keyword = $this->request->query('keyword');
        $condition[] = ['Users.role !=' => 'Admin'];
		if(@$this->request->query('role') != ''){
			$condition[] = ['Users.role' => $this->request->query('role')];
		}
		if(@$this->request->query('status') != ''){
			$condition[] = ['Users.status' => $this->request->query('status')];
		}
        if($keyword != ''){
			$condition[] = [
				'OR' => [
					["Users.fullName LIKE '%".$keyword."%'"],
					["Users.email LIKE '%".$keyword."%'"],
					["Users.country LIKE '%".$keyword."%'"],
					["Users.role LIKE '%".$keyword."%'"],
					["Users.contactNumber LIKE '%".$keyword."%'"]
				]				
			];
		}        
        $query = $this->Users->find('all')->where($condition);       
        $users = $this->paginate($query);
        $users = $users->toArray();
        $this->set(compact('users', 'limit'));
    }

    
   
    
    
    
    
    
    /********************************************************************************
	Function Name: add
	*Type: Public function used as action of the controller
	*Input: No input
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to add new QuiQR member.
	*********************************************************************************/
    public function add()
    {
		$this->loadModel('Usereducations');
        $layoutTitle = 'QuiQR::Add New Member';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');
		$url = Router::url('/', true);
		$breadcum = [
					 'Title' => 'User Management/Add User',
					 'URL'=>[
							   'Dashboard' => $url,
							   'Add User' => ''
							]
					 ];
		
        $users = $this->Users->newEntity();        
       
        if ($this->request->is('post')) {
            //pr($this->request->data); die;
            $this->request->data['username'] = $this->request->data['email']; 			
				
				  
				$userImage = $this->request->data['profile_picture'];	
				unset($this->request->data['profile_picture']);			
				if(!empty($userImage['name'])){
					$filename = time() .'_'. $userImage['name'];
					//$users['profile_picture'] = $filename;
					$this->request->data['profile_picture'] = $filename;
				}
				
				$users = $this->Users->patchEntity($users, $this->request->data, ['validate' => 'customer']);            
				$users['created'] = date('Y-m-d H:i:s'); 
				//$users['role'] = 'Member'; 
				if ($this->Users->save($users)) {
					if (!empty($userImage) && $userImage['name'] != '') {
						$path = WWW_ROOT . 'img/uploads/users/';	                    
						move_uploaded_file($userImage['tmp_name'], $path.$filename);
						@chmod($path.$filename, 0777);
						$MyImageCom = new ImgComponent();
						$MyImageCom->prepare("img/uploads/users/".$filename);
						$MyImageCom->resize(150,100);
						$MyImageCom->save("img/uploads/users/thumb/".$filename);
						@chmod(WWW_ROOT."img/uploads/users/thumb/".$filename, 0777);
					}
					if($this->request->data['CollegeName'][0]){
						for($i=0; $i<count($this->request->data['CollegeName']); $i++){
							$Usereducations = $this->Usereducations->newEntity();
							$EDUCATION['CollegeName'] = @$this->request->data['CollegeName'][$i];
							$EDUCATION['CourseName'] = @$this->request->data['CourseName'][$i];
							$EDUCATION['PassOut'] = @$this->request->data['PassOut'][$i];
							$EDUCATION['Markes'] = @$this->request->data['Markes'][$i];
							$EDUCATION['status'] = 1;
							$EDUCATION['userId'] = $users->id;
							$Usereducations = $this->Usereducations->patchEntity($Usereducations, $EDUCATION, ['validate' => false]);
							$Usereducations['created'] = date('Y-m-d H:i:s');
							$this->Usereducations->save($Usereducations);
						}
					}
					
                    $this->Flash->success(__('Member added successfully.'));
                    return $this->redirect(['action' => 'index']);	
				}else{
                    //pr($users);die;
					$this->Flash->error(__('Unable to add new member, Please try again later.'));
				}
		}
        $this->set(compact('users','breadcum'));
    }
    
    
    
    
    /********************************************************************************
	Function Name: edit
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to edit evs member.
	*********************************************************************************/
    public function edit($id)
    {
		if($this->request->session()->read('PERMISSION.departmentnameId4.editPermission') == 0){
			$this->Flash->error(__('You have not permission to access this.'));
			return $this->redirect(['controller'=>'Admins','action' => 'dashboard']);	
		}
		$this->loadModel('Usereducations');
        $layoutTitle = 'QuiQR::Edit Member';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');
        $url = Router::url('/', true);
		$breadcum = [
					 'Title' => 'User Management/Edit User',
					 'URL'=>[
							   'Dashboard' => $url,
							   'Edit User' => ''
							]
					 ];
        $users = $this->Users->find()->where(['Users.id' => $id])->contain(['Usereducations'])->first();//fields name in contain[] with coma
        if ($this->request->is(['patch', 'post', 'put'])) {
			
			if($this->request->data['password'] == '' && $this->request->data['confirm_password'] == ''){
				unset($this->request->data['password']);
				unset($this->request->data['confirm_password']);
			}			
			unset($this->request->data['email']);
			$userImage = $this->request->data['profile_picture'];	
			unset($this->request->data['profile_picture']);
			unset($users['profile_picture']);
			
			$old_data = $this->Users->get($id);            			
			if(!empty($userImage['name'])){
				$filename = time() .'_'. $userImage['name'];
				$users['profile_picture'] = $filename;
				$this->request->data['profile_picture'] = $filename;
			}	
			
			$users = $this->Users->patchEntity($users, $this->request->data, ['validate' => 'customer']);
			
			if(!empty($filename)){				
				$oldfilename = $old_data->profile_picture;
			}	
			if ($this->Users->save($users)) {								
				if (!empty($userImage) && $userImage['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/users/';	
					@unlink(WWW_ROOT . 'img/uploads/users/'.$oldfilename);
					@unlink(WWW_ROOT . 'img/uploads/users/thumb/'.$oldfilename);
					move_uploaded_file($userImage['tmp_name'], $path.$filename);
					@chmod($path.$filename, 0777);
					$MyImageCom = new ImgComponent();
					$MyImageCom->prepare("img/uploads/users/".$filename);
					$MyImageCom->resize(150,100);
					$MyImageCom->save("img/uploads/users/thumb/".$filename);
					@chmod(WWW_ROOT."img/uploads/users/thumb/".$filename, 0777);
					
				}
				for($i=0; $i<count($this->request->data['CollegeName']); $i++){
					$Usereducations = $this->Usereducations->newEntity();
					$EDUCATION['CollegeName'] 	= @$this->request->data['CollegeName'][$i];
					$EDUCATION['CourseName'] 	= @$this->request->data['CourseName'][$i];
					$EDUCATION['PassOut'] 		= @$this->request->data['PassOut'][$i];
					$EDUCATION['Markes'] 		= @$this->request->data['Markes'][$i];
					$EDUCATION['status']		= 1;
					$EDUCATION['userId'] 		= $users->id;
					$EDUCATION['id'] 			= @$this->request->data['eduId'][$i];
					$Usereducations = $this->Usereducations->patchEntity($Usereducations, $EDUCATION, ['validate' => false]);
					$Usereducations['created'] = date('Y-m-d H:i:s');
					$this->Usereducations->save($Usereducations);
				}
				$this->Flash->success(__('The member updated successfully.'));
                return $this->redirect(['action' => 'index']);
			} else {
				$users['profile_picture'] = $old_data->profile_picture;
				$this->Flash->error(__('Member information could not be saved. Please try again later.'));
			}
        }
		$this->set(compact('countries', 'states', 'cities'));		
        $this->set(compact('users','breadcum'));
    }
    
    
    /********************************************************************************
	Function Name: edit
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to delete QuiQR member permanently.
	*********************************************************************************/
    public function delete($id = null)
    {
		if($this->request->session()->read('PERMISSION.departmentnameId4.deletePermission') == 0){
			$this->Flash->error(__('You have not permission to access this.'));
			return $this->redirect(['controller'=>'Admins','action' => 'dashboard']);	
		}
        $users = $this->Users->get($id);
        if ($this->Users->delete($users)) {
			@unlink(WWW_ROOT . 'img/uploads/users/original/'.$users->profilePicture);
			@unlink(WWW_ROOT . 'img/uploads/users/thumb/'.$users->profilePicture);
            $this->Flash->success(__('Member has been deleted.'));
        } else {
            $this->Flash->error(__('Member could not be deleted. Please, try again.'));
        }
        return $this->redirect(['controller' => 'Users', 'action' => 'index']);
    }
    
    
    /********************************************************************************
	Function Name: status
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to update QuiQR member status.
	*********************************************************************************/
    public function status($id){
		$users = $this->Users->get($id);
		$query_String = $_SERVER["QUERY_STRING"];
		$status = '1';
		$msg = 'activated';
		if($users->status == '1'){
			$status = '0';
			$msg = 'deactivated';
		}
		
		$articles = TableRegistry::get('Users');
		$query = $articles->query();
		$query->update()
			->set(['status' => $status])
			->where(['id' => $id])
			->execute();
		$this->Flash->success(__('Member has been '.$msg.' successfully.'));
		
		return $this->redirect(['controller' => 'Users', 'action' => 'index/?'.$query_String]);
		
	}
    
    
	
    /********************************************************************************
	Function Name: details
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to view QuiQR member information.
	*********************************************************************************/
    public function details($id){
		if($this->request->session()->read('PERMISSION.departmentnameId4.viewPermission') == 0){
			$this->Flash->error(__('You have not permission to access this.'));
			return $this->redirect(['controller'=>'Admins','action' => 'dashboard']);	
		}
        $layoutTitle = 'QuiQR::Member Details';
		$url = Router::url('/', true);
		$breadcum = [
					 'Title' => 'User Management/User Details',
					 'URL'=>[
							   'Dashboard' => $url,
							   'User Details' => ''
							]
					 ];
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');        
		$users = $this->Users->find()->where(['Users.id' => $id])->first();
        if(!empty($users)){
            $this->set(compact('breadcum','users'));
        }else{
            $this->Flash->error(__('Member doesnot exist.'));
            return $this->redirect(['controller' => 'Users', 'action' => 'index']);
        }
	}
	
	
}