<?php
namespace App\Model\Table;

use Cake\ORM\Table;
use Cake\Validation\Validator;
use Cake\Auth\DefaultPasswordHasher;
//use Cake\ORM\RulesChecker;
 
class FeaturesTable extends Table
{
    public function initialize(array $config)
    {
        
		$this->belongsTo('Users', [
            'className' => 'Users',
            //'bindingKey' => ['clientId'],
			'foreignKey' => ['userId']
        ]);
		$this->belongsTo('Products', [
            'className' => 'Products',
            //'bindingKey' => ['clientId'],
			'foreignKey' => ['productId']
        ]);
    }
    
    public function validationCustomer(Validator $validator)
    {
       
		//$validator->notEmpty('SKU', 'Please enter SKU.');
		$validator
			->notEmpty('SKU', 'Please enter SKU.')
			 ->add('SKU', 'unique',[
                    'rule' => 'validateUnique',
                    'provider' => 'table',
                    'message' => 'SKU already exist'
			]);
		$validator->notEmpty('userId', 'Please select user.');
		$validator->notEmpty('categoryId', 'Please select category.');
		$validator->notEmpty('productName', 'Please enter name.');
		$validator->notEmpty('quantity', 'Please enter quantity.');
		$validator->notEmpty('price', 'Please enter price.');
		
		$validator->notEmpty('NCIName', 'Please enter NCI Name.');
		$validator->notEmpty('contactEmail', 'Please enter contact Email.');
		
		$validator->add('specialPrice', [      
				'specialPrice' => [                    
					'rule'=>  function($value,$context){
						if ($value <= $context['data']['price']) {							
							return true;
						}
						return false;
					},
					'message'=>'Special price must be same or less then price',
                ]
		])->notEmpty('specialPrice');
		//$validator->notEmpty('designation', 'Please enter feature designation.');
        $validator->add('image', [      
				'image' => [                    
					'rule'=>  function($value){
						$ext = explode(".", $value);
						$extension = strtolower(end($ext));
						
						if (in_array(trim($extension), array('jpg', 'jpeg', 'png', 'gif'))) {							
							return true;
						}
						return false;
					},
					'message'=>'Please select jpg, jpeg, gif and png only.',
                ]
		])->notEmpty('image');
        return $validator;
    }
    
    
    
	
    
    
    
    
    
    
   

}
